/* lab13a.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>

#define I_MAX_VALOR    254
#define SZ_FORMATO     "Formato: p <#primos>\n"
#define SZ_MAX_PRIMOS  "O maximo de primos permitido e' %d.\n"
#define SZ_ERRO_CRIA   "Erro na criacao do thread %d.\n"
#define SZ_ERRO_MEM    "Erro de falta de memoria.\n"
#define SZ_NUM_ENC     "Thread %d achou primo %d.\n"
#define SZ_TERMINOU    "Todos os primos foram achados.\n"
#define SZ_TERMINANDO  "Thread %d terminando.\n"
#define SZ_MORRENDO    "Thread %d morrendo. AHHHHHHHHHHHHHHHHHHHHHHHHHH!!!!!!\n"


typedef struct {
   pthread_mutex_t MonPipe    ;
   pthread_cond_t  CondPassa  ,
                   CondRecebe ;
   int             iIdThread  ,
                   iValorImp  ;
} tpPipe ;


typedef struct {
   pthread_mutex_t MonitorBarr  ;
   pthread_cond_t  CondChegou   ;
   int             iNumChegaram ;
} tpBarreira ;


int        n                                           , /* numero de primos */
           iAcabou  = 0                                ;
tpBarreira Barreira = { PTHREAD_MUTEX_INITIALIZER,
                        PTHREAD_COND_INITIALIZER , 0 } ;


void CriarTestadora( tpPipe** ppPipe    ,
                     int      iIdThread  ) ;

void GerarImpares( void ) ;

void* TestarPrimo( void* pPipe ) ;

void TestarFim( int iIdThread ) ;

void Terminar( tpPipe* pPipe     ,
               int     iIdThread  ) ;

void PassarValor( tpPipe* pPipe     ,
                  int     iValorImp  ) ;

int iReceberValor( tpPipe* pPipe ) ;


void CriarTestadora( tpPipe** ppPipe    ,
                     int      iIdThread  ) {

   int      iErro       ;
   pthread_t NovaThread ;

   *ppPipe = ( tpPipe* )malloc( sizeof( tpPipe ) ) ;
   if ( *ppPipe == NULL ) {
      printf( SZ_ERRO_MEM ) ;
      exit( 1 ) ;
   } /* if */

   pthread_mutex_init( &( ( *ppPipe )->MonPipe ), NULL ) ;
   pthread_cond_init( &( ( *ppPipe )->CondPassa ), NULL ) ;
   pthread_cond_init( &( ( *ppPipe )->CondRecebe ), NULL ) ;
   ( *ppPipe )->iIdThread = iIdThread ;
   ( *ppPipe )->iValorImp = 0 ;

   iErro = pthread_create( &NovaThread, NULL, TestarPrimo,
                                              ( void* )( *ppPipe ) ) ;

   if ( iErro != 0 ) {
      printf( SZ_ERRO_CRIA, iIdThread ) ;
      exit( 1 ) ;
   } /* if */

} /* CriarTestadora */


void GerarImpares( void ) {
   int     iValorImp = 1 ,
           iJaCriei  = 0 ;
   tpPipe* pMeuPipe      ;

   TestarFim( 1 ) ;

   while ( 1 ) {
      iValorImp += 2 ;

      Terminar( NULL, 1 ) ;

      if ( iJaCriei == 0 
        && n > 1 ) {
         CriarTestadora( &pMeuPipe, 2 ) ;
         iJaCriei = 1 ;
      } /* if */

      PassarValor( pMeuPipe, iValorImp ) ;
   } /* while */

} /* GerarImpares */


void* TestarPrimo( void* pPipe ) {
   int     iJaCriei   = 0                ,
           iMeuValor  = 0                ;
   tpPipe* pMeuPipe                      ;
   tpPipe* pOutroPipe = ( tpPipe* )pPipe ;

   while ( 1 ) {
      int iValorImp = iReceberValor( pOutroPipe ) ;
      
      if ( iMeuValor == 0 ) {
         iMeuValor = iValorImp ;        
         printf( SZ_NUM_ENC, pOutroPipe->iIdThread, iMeuValor ) ;
         fflush( stdout ) ;
         TestarFim( pOutroPipe->iIdThread ) ;
      } /* if */

      Terminar( pOutroPipe, pOutroPipe->iIdThread ) ;

      if ( iValorImp % iMeuValor != 0 ) {
         if ( iJaCriei == 0 ) {
            CriarTestadora( &pMeuPipe, pOutroPipe->iIdThread + 1 ) ;
            iJaCriei = 1 ;
         } /* if */
         PassarValor( pMeuPipe, iValorImp ) ;
      } /* if */
  
   } /* while */

} /* TestarPrimo */            
   

void TestarFim( int iIdThread ) {

   if ( n == iIdThread ) {
      printf( SZ_TERMINOU ) ;
      fflush( stdout ) ;
      iAcabou = 1 ;
   } /* if */
      
} /* TestarFim */


void Terminar( tpPipe* pPipe     ,
               int     iIdThread  ) {

   pthread_mutex_lock( &Barreira.MonitorBarr ) ;

   if ( iAcabou == 1 ) {
      printf( SZ_TERMINANDO, iIdThread ) ;
      fflush( stdout ) ;
      Barreira.iNumChegaram++ ;

      while ( Barreira.iNumChegaram < n ) {
         if ( pPipe != NULL ) {

            pthread_mutex_lock( &( pPipe->MonPipe ) ) ;

            pthread_cond_signal( &( pPipe->CondPassa ) ) ;
            pthread_cond_signal( &( pPipe->CondRecebe ) ) ;

            pthread_mutex_unlock( &( pPipe->MonPipe ) ) ;  

         } /* if */ 
         pthread_cond_wait( &Barreira.CondChegou, &Barreira.MonitorBarr ) ;
      } /* while */

      pthread_cond_broadcast( &Barreira.CondChegou ) ;
      printf( SZ_MORRENDO, iIdThread ) ;
      fflush( stdout ) ; 

      if ( pPipe != NULL ) {
         free( pPipe ) ;
      } /* if */ 

      pthread_mutex_unlock( &Barreira.MonitorBarr ) ;

      pthread_exit( NULL ) ;
   } /* if */

   pthread_mutex_unlock( &Barreira.MonitorBarr ) ;

} /* Terminar */


void PassarValor( tpPipe* pPipe     ,
                  int     iValorImp  ) {

   pthread_mutex_lock( &( pPipe->MonPipe ) ) ;

   while ( pPipe->iValorImp != 0 
        && iAcabou == 0 ) {
      pthread_cond_wait( &( pPipe->CondPassa ), &( pPipe->MonPipe ) ) ;
   } /* while */

   pPipe->iValorImp = iValorImp ;
   pthread_cond_signal( &( pPipe->CondRecebe ) ) ;

   pthread_mutex_unlock( &( pPipe->MonPipe ) ) ;

} /* PassarValor */


int iReceberValor( tpPipe* pPipe ) {
   int iValorImp ;

   pthread_mutex_lock( &( pPipe->MonPipe ) ) ;

   while ( pPipe->iValorImp == 0 
        && iAcabou == 0 ) {
      pthread_cond_wait( &( pPipe->CondRecebe ), &( pPipe->MonPipe ) ) ;
   } /* while */

   iValorImp = pPipe->iValorImp ;
   pPipe->iValorImp = 0 ;
   pthread_cond_signal( &( pPipe->CondPassa ) ) ;

   pthread_mutex_unlock( &( pPipe->MonPipe ) ) ;

   return iValorImp ;
} /* iReceberValor */


int main( int   argc    ,
          char* argv[ ]  ) {

   if ( argc != 2 ) {
      printf( SZ_FORMATO ) ;
      return 0 ;
   } /* if */

   n = atoi( argv[ 1 ] ) ;
   
   if ( n > I_MAX_VALOR ) {
      printf( SZ_MAX_PRIMOS, I_MAX_VALOR ) ;
      return 0 ;
   } /* if */

   if ( n > 0 ) {
      printf( SZ_NUM_ENC, 1, 2 ) ;
      GerarImpares( ) ;
   } /* if */

   return 0 ;
}
